<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo />
                <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('iven-report') }}</h1>
            </div>
            <Header />
            <ol id="topicPath">
                <li style="margin-left:345px">
                    <router-link to="menustock"><a href="dashbaord">
                            <font style="vertical-align: inherit">
                                <font style="vertical-align: inherit">{{ i18ntext.lngText('iven-report') }}</font>
                            </font>
                        </a>
                    </router-link>
                </li>
            </ol>
        </div>
        <div class="search-box">
            <div id="product">
                <div class="search-box mb-4">
                    <div class="search-title" id="Bars" style="padding-left:2rem">
                        <div id="bar" style="width: 85%;">
                            <router-link to="/report">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('report') }}
                                </a>
                            </router-link>
                            <router-link to="/salereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('sale-report') }}
                                </a>
                            </router-link>
                            <router-link to="/closereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('close-report') }}
                                </a>
                            </router-link>
                            <router-link to="/saleitem">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('item-report') }}
                                </a>
                            </router-link>
                            <router-link to="/stockinven">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1"
                                    style="background-color: #29a5a5; border: #22adb763 1px solid;">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('iven-report') }}
                                </a>
                            </router-link>
                            <router-link to="/expensesreport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('exp-report') }}
                                </a>
                            </router-link>
                            <router-link to="/incomereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('icm-report') }}
                                </a>
                            </router-link>
                            <router-link to="/incomepen">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('icm-exp') }}
                                </a>
                            </router-link>
                        </div>
                        <div id="right">
                            <a id="menu-1" class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown"
                                aria-expanded="false"
                                style="float: right; color: #f8f5b4; margin-top: 0;margin-right: 0; margin-left: auto;margin-right: 11px;">
                                <i class="fas fa-plus"></i>
                                {{ i18ntext.lngText('menu') }}
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a @click="getsuppliyerview()" class="dropdown-item btn btn-primary"
                                        data-bs-toggle="modal" data-bs-target="#staticboomId" tabindex="10028">
                                        <i class="fa fa-print" aria-hidden="true"></i>
                                        {{ i18ntext.lngText('print') }}
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <input autocomplete="off" id="search" name="search" type="hidden" value="1" />
                    <div class="box">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="table table-striped br-table">
                            <thead>
                                <tr class="header-table">
                                    <th colspan="3">
                                        <input autocomplete="off" style="width: 100%;" v-model="formSearch.doc" @input="mySearch()"
                                            name="search" placeholder="Document Type" type="search" id="search" class="text" />
                                    </th>
                                    <th colspan="3">
                                        <input autocomplete="off" style="width: 100%;" v-model="formSearch.no" @input="mySearch()"
                                            name="search" placeholder="Product No" type="search" id="search"
                                            class="text" />
                                    </th>
                                    <th colspan="2">
                                        <input autocomplete="off" style="width: 100%;" v-model="formSearch.des" @input="mySearch()"
                                            name="search" placeholder="Description" type="search" id="search"
                                            class="text" />
                                    </th>
                                    <th class="exp">
                                        <div>
                                            <span>
                                                <input autocomplete="off" v-model="formSearch.startDate" @input="mySearch()" id="search"
                                                    name="search" type="date" class="text" placeholder="Search"
                                                    style="margin-right: 0px !important;width: 85px;">
                                            </span>
                                            <span style="margin: 0px 3px;">To</span>
                                            <span>
                                                <input autocomplete="off" id="search" name="search" type="date" v-model="formSearch.endDate"
                                                    @input="mySearch()" class="text" placeholder="Search"
                                                    style="margin-right: 0px !important;width: 85px;">
                                            </span>
                                        </div>
                                    </th>
                                </tr>
                                <tr class="header-table">
                                    <th style="width: 4%;">{{ i18ntext.lngText('no') }}</th>
                                    <th style="width: 11%;">{{ i18ntext.lngText('document_type') }}</th>
                                    <th style="width: 13%;">{{ i18ntext.lngText('pro-no') }}</th>
                                    <th style="min-width: 35% !important;">{{ i18ntext.lngText('description') }}</th>
                                    <th style="width: 11%;">{{ i18ntext.lngText('sale-iven') }}</th>
                                    <th style="width: 9%;">{{ i18ntext.lngText('inventory') }}</th>
                                    <th style="width: 11%;">{{ i18ntext.lngText('iven-old') }}</th>
                                    <th style="width: 9%;">{{ i18ntext.lngText('total_amount') }}</th>
                                    <th style="width: 10%;">{{ i18ntext.lngText('expire') }}</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(item, index) in items.data" :key="index">
                                    <td>{{ 15*(number - 1)  + (index + 1)}}</td>
                                    <td>{{ item.document_type }}</td>
                                    <td>{{ item.product_no }}</td>
                                    <td>{{ item.description }}</td>
                                    <td>
                                        <div style="display: flex;justify-content: end;">
                                            {{ Number(parseFloat(item.inventory_new) -
                                                parseFloat(item.inventory)).toLocaleString() }}
                                            <span style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                {{ item.unit_of_measure_code }}
                                            </span>
                                        </div>
                                    </td>
                                    <td>
                                        <div style="display: flex;justify-content: end;">
                                            {{ Number(item.inventory).toLocaleString() }}
                                            <span style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                {{ item.unit_of_measure_code }}
                                            </span>
                                        </div>
                                    </td>
                                    <td>
                                        <div style="display: flex;justify-content: end;">
                                            {{ Number(item.inventory_new).toLocaleString() }}
                                            <span style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                {{ item.unit_of_measure_code }}
                                            </span>
                                        </div>
                                    </td>
                                    <td>
                                        <div style="display: flex;justify-content: end;">
                                            {{ Number(parseFloat(item.unit_price) *
                                                parseFloat(item.inventory)).toLocaleString() }}
                                            <span style="padding-left: 3px;" v-if="this.form.curency_code == 'USD'"> $
                                            </span>
                                            <span style="padding-left: 3px;" v-else> ៛ </span>
                                        </div>
                                    </td>
                                    <td>
                                        <div style="display: flex;justify-content: end;">
                                            {{ formatdatetime(item.exprit_date) }}
                                        </div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div class="box-footer-pagination">
                            <pagination :limit="2" :data="items" @pagination-change-page="mySearch" />
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="staticboomId" aria-hidden="true">
        <div class="modal-dialog" style="max-width: 90% !important;">
            <div class="modal-content ui-dialog" style="height: 90vh !important;">
                <div class="ui-widget-header">
                    <h5 class="modal-title in-header" id="staticBackdropLabel"><i class="fa fa-print"
                            aria-hidden="true"></i>
                            {{ i18ntext.lngText('print') }}</h5>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content print-size" style="height: 200vh !important;">
                    <div class="card">
                        <div class="card-body" id="purchaseorder" style="padding: 30px 30px !important;">
                            <div class="mt-3 ">
                                <div style="background-color: #fff;">
                                    <div class="col-md-12">
                                        <div class="text-center">
                                            <h3 class="title-purchase">{{ i18ntext.lngText('iven-rep') }}</h3>
                                        </div>
                                    </div>
                                    <div class="col-container">
                                        <div class="col1">
                                            <p class=" p-bg font-size p-pad">{{ i18ntext.lngText('com-name') }}</p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('name') }} :</span> <span id="fon">{{
                                                company.company_name
                                            }}</span></p>
                                            <p class="p-mg  info-pad"><span id="bold">{{ i18ntext.lngText('phone') }} :</span> <span
                                                    id="fon">{{
                                                        company.company_Phone }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('email') }} :</span> <span
                                                    id="fon">{{
                                                        company.company_Email }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('address') }} :</span> <span id="fon">{{
                                                company.company_Address }}</span></p>
                                        </div>
                                        <div class="col2">
                                            <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('date') }}</p>
                                            <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                                            <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('onhand-total') }}.</p>
                                            <p class="text-center p-mg">{{ count }}</p>
                                        </div>
                                    </div>
                                    <div class=" my-2  justify-content-center">
                                        <table id="pr-tb">
                                            <thead>
                                                <tr class="p-bg">
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('no') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('document_type') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('pro-no') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('description') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('sale-iven') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('inventory') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('iven-old') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('total_amount') }}</th>
                                                    <th style="padding-left: 5px !important;">{{ i18ntext.lngText('expire') }}</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr v-for="(item, index) in prints.print" :key="item.index">
                                                    <td>{{ index + 1 }}</td>
                                                    <td>{{ item.document_type }}</td>
                                                    <td>{{ item.product_no }}</td>
                                                    <td>{{ item.description }}</td>
                                                    <td>
                                                        <div style="display: flex;justify-content: end;">
                                                            {{ Number(parseFloat(item.inventory_new) -
                                                                parseFloat(item.inventory)).toLocaleString() }}
                                                            <span
                                                                style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                                {{ item.unit_of_measure_code }}
                                                            </span>
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div style="display: flex;justify-content: end;">
                                                            {{ Number(item.inventory).toLocaleString() }}
                                                            <span
                                                                style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                                {{ item.unit_of_measure_code }}
                                                            </span>
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div style="display: flex;justify-content: end;">
                                                            {{ Number(item.inventory_new).toLocaleString() }}
                                                            <span
                                                                style="text-align: left; color: rgb(17, 38, 235);padding-left: 3px;">
                                                                {{ item.unit_of_measure_code }}
                                                            </span>
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div style="display: flex;justify-content: end;">
                                                            {{ Number(parseFloat(item.unit_price) *
                                                                parseFloat(item.inventory)).toLocaleString() }}
                                                            <span style="padding-left: 3px;"
                                                                v-if="this.form.curency_code == 'USD'"> $ </span>
                                                            <span style="padding-left: 3px;" v-else> ៛ </span>
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div style="display: flex;justify-content: end;">
                                                            {{ formatdatetime(item.exprit_date) }}
                                                        </div>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <div class="prn">
                                            <li style="width: 29%;display: flex;justify-content: end;">{{ i18ntext.lngText('total_amount') }} : {{ Number(sum).toLocaleString()
                                            }}<span class="li-span" style="padding-left: 3px;">៛</span></li>
                                        </div>
                                    </div>
                                    <hr>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button v-print="'#purchaseorder'" class="btn-purchase btn-light text-capitalize border-0">
                        <i class="fa fa-print text-primary"></i> {{ i18ntext.lngText('print') }}
                    </button>
                </div>
            </div>
        </div>
    </div>
    <div id="myModal" class="lskymodal">
        <div class="lskymodal-content">
            <p>
                <i class="fa fa-check" aria-hidden="true"></i>
                {{ massege }}
            </p>
        </div>
    </div>

    <Footer />
    <UserInfo />
</template>

<script>
import axios from "axios";
import { useCurrentTime } from "../../componentJS/date";
import pagination from "laravel-vue-pagination";
import moment from "moment";
import Footer from "../footer.vue"
import Logo from "../logo.vue"
import print from 'vue3-print-nb';
import Auth from "../../auth/Auth";
import Header from "../Header.vue";
import UserInfo from "../UserInfo.vue"
import i18n from "../../i18n/i18n";
export default {
    components:
    {
        Header, Logo, pagination, Footer,UserInfo
    },
    setup() {
        const { currentTime } = useCurrentTime();
        return { currentTime };
    },
    directives: {
        print
    },
    data() {
        return {
            i18ntext: i18n,
            Categories: [],
            selectdate: '',
            selectmoth: '',
            selectyear: '',
            links: [],
            company: [],
            perPage: "",
            currentPage: 0,
            last_page: 1,
            action_api: "",
            action_api_1: "",
            formatdate: "",
            isDisabled: false,
            items: [],
            prints: [],
            search: "",
            sum: 0,
            count: 0,
            massege: "",
            form: {
                id: "",
                document_no: "",
                document_type: "",
                product_no: "",
                description: "",
                issu_date: "",
                exprit_date: "",
                unit_of_measure_code: "",
                line_no: "",
                unit_price: "",
                inventory: "",
                inventory_new: "",
                inventory_old: "",
                total_amount: "",
                curency_code: "",
                remark: "",
                statue: "",
                created_by: "",
                updated_by: "",
                created_at: "",
                updated_at: "",
            },
            formSearch: {
                doc: "",
                no:"",
                des:"",
                startDate: "",
                endDate: "",
            },
            formOpen: {
                id: "",
                description: "",
                deposit: "",
                deposit2: "",
                curency: "",
                statue: "",
                created_by: Auth.user.user_code,
                updated_by: '',
            },
            getcloseshifts: [],
            getamount: 0,
            total_amountusd: 0,
            Employee_Name: Auth.user.user_name,
            pospayment: {
                amount: 0,
                amount2: 0,
                amount_kh: 0,
                totalpay: 0,
                discount: 0,
                changeUS: 0,
                changeKH: 0,
                payOne: '',
                payTwo: '',
                amountUSD: 0,
                exchange_rate: 0,
                paymeny_method: 'Cash'
            },
            number_page : 1,
            number : 1,
        };
    },

    mounted() {
        if (Auth.check()) {
        if(!Auth.checkPermission('STOCKINVENREPORT_ALL')){
            this.$router.push('/dashboard');
        }
    }
        this.selectdate = moment(new Date()).format('YYYY-MM-DD');
        this.selectmoth = moment(new Date()).format('YYYY-MM');
        this.selectyear = moment(new Date()).format('YYYY');
        this.getcompany();

        this.formSearch.endDate = moment(new Date()).format('YYYY-MM-DD');
        const myDate = new Date();
        this.formSearch.startDate = moment(myDate.setMonth(myDate.getMonth() - 1)).format('YYYY-MM-DD');

        let myPagenumber = this.$route.query
        if(JSON.stringify(myPagenumber) === '{}'){
            this.number = 1
        } 
        else {
            this.number = this.$route.query.page
        }


        if(this.$route.query.page != 1){
            this.number_page = this.$route.query.page
            this.formSearch.page = this.number_page
            axios.post("api/v1/pos/shinven/" + Auth.user.id, this.formSearch)
                .then(res => {
                    this.items = res.data.data
                    this.prints = res.data
                    this.count = this.prints.print.length
           
                    this.sum = 0
                    this.massege = "Data has found."
                    this.messagebox()
                    this.count = this.items.data.length
                    if (this.count == 0) {
                        this.massege = "No data not found!"
                        this.messagebox()
                    }
                    this.prints.print.forEach(element => {
                        this.sum += parseFloat(element.unit_price) * parseFloat(element.inventory)
                    })
                })
        }else{
            this.mySearch()
        }
       
    },

    methods: {
        formatyear() {
            document.querySelector("input[type=number]")
                .oninput = e => console.log(e.target.valueAsNumber)
        },
        getclose(page = 1) {
            this.$router.push({name: 'stockinven', query: {page : page}})
            
            axios.post("api/v1/pos/getinven/" + Auth.user.id + "?page=" + page)
                .then(res => {
                    this.items = res.data.data
                    this.prints = res.data
                    this.sum = 0
                    this.prints.print.forEach(element => {
                        this.sum += parseFloat(element.unit_price) * parseFloat(element.inventory)

                    })
                })

        },
        async getcompany() {
            axios.get("/api/v1/getSetup/")
                .then((response) => {
                    this.company = response.data;
                    this.dateformart = moment(new Date()).format('YYYY-MM-DD');
                });
        },
        mySearch(page = 1) {
            this.formSearch.page = page
            this.$router.push({name: 'stockinven', query: {page : page}})
            axios.post("api/v1/pos/shinven/" + Auth.user.id, this.formSearch)
                .then(res => {
                    this.items = res.data.data
                    this.prints = res.data
                    this.count = this.prints.print.length
                    console.log(this.count);
                    this.number = this.$route.query.page
                    this.sum = 0
                    this.massege = "Data has found."
                    this.messagebox()
                    this.count = this.items.data.length
                    if (this.count == 0) {
                        this.massege = "No data not found!"
                        this.messagebox()
                    }
                    this.prints.print.forEach(element => {
                        this.sum += parseFloat(element.unit_price) * parseFloat(element.inventory)
                    })
                })
        },
        messagebox() {
            var modal = document.getElementById("myModal");
            modal.style.display = "block";
            setTimeout(() => (modal.style.display = "none"), 2000);
        },
        getcloseshift(data) {
            $('#closeshift').modal('show');
            data.created_by = Auth.user.id;
            this.formOpen = data
            axios.post("/api/v1/pos/detailcloseshif/", data)
                .then((res) => {
                    this.getamount = 0;
                    this.total_amountusd = 0;
                    this.getcloseshifts = res.data;
                    this.getcloseshifts.forEach(element => {
                        this.getamount += parseFloat(element.total_amount);
                        this.total_amountusd += parseFloat(element.total_amount_usd);
                    });
                });
        },
        formatPrice(value, cur) {
            if (cur == "KHR") cur = "r";
            try {
                var formatter = new Intl.NumberFormat("en-US", {
                    style: "currency",
                    currency: cur,
                    minimumFractionDigits: 2,
                });
                return formatter.format(value);
            } catch (error) {
                var formatter = new Intl.NumberFormat("en-US", {
                    minimumFractionDigits: 2,
                });
                return formatter.format(value);
            }
        },
        formatdatetime(dateform) {
            try {
                return this.dateformart = moment(dateform).format('DD-MM-YYYY');
            } catch (error) {
                return dateform;
            }
        },
        async printDivContent() {
            var contentOfDiv = document.getElementById("paypos1").outerHTML;
            var newWin = window.open('invoice', '', 'height=auto, width=400');
            await newWin.document.write('<title>Print Content of Div element by  using Javascript</title>');
            await newWin.document.write('<link rel="stylesheet" href="css/style.css">');
            await newWin.document.write('<link rel="stylesheet" href="css/pstyle.css">');
            await newWin.document.write('<link rel="stylesheet" href="css/body_invoice.css">');
            await newWin.document.write(contentOfDiv);
            newWin.document.close();
            await newWin.print();
            newWin.window.close();
            this.getdataPos();
        },

    },
};
</script>
